<template>
  <v-select
    v-model="selectedProperty"
    label="Объект"
    :items="properties"
    :loading="isLoading"
    hide-details
    return-object
    @update:focused="onFocus"
  >
    <template #prepend-item>
      <section class="p-3">
        <v-text-field
          :clearable="!isLoading"
          flat
          variant="solo-filled"
          prepend-inner-icon="mdi-magnify"
          placeholder="Поиск"
          type="input"
          hide-details
          density="comfortable"
          @input="onSearchInput"
          @click:clear="term = ''"
        >
          <template #append-inner>
            <v-btn
              v-tooltip:left="{ text: `Минимум символов: ${MIN_SEARCH_TERM_LENGTH}`, openOnClick: true }"
              icon="mdi-shield-alert-outline"
              variant="plain"
              size="small"
              :ripple="false"
            />
          </template>
        </v-text-field>
      </section>
    </template>

    <template #item="{ item, props }">
      <!--Leave title empty to fix vue warnings-->
      <v-list-item
        v-bind="props"
        title=""
        class="py-2"
      >
        <template #title>
          <section class="flex items-center gap-2">
            <section
              class="w-3 h-3 rounded-full"
              :style="{ 'background-color': item.value.color }"
            />

            <section>
              {{ item.value.name }}
            </section>
          </section>
        </template>

        <template #subtitle>
          <section class="flex items-center mt-2 ml-5">
            <span class="text-gray-600 text-center leading-none">
              <v-icon
                icon="mdi-bed-outline"
                size="small"
              />
            </span>

            <span class="tracking-wider font-bold leading-none mx-1">
              {{ item.value.capacity }}
            </span>

            <span class="leading-none text-gray-600">
              {{ getCapacityLabel(item.value.capacity) }}
            </span>
          </section>
        </template>
      </v-list-item>
    </template>

    <template #selection="{ item }">
      <section class="flex items-center gap-2">
        <section
          class="w-3 h-3 rounded-full"
          :style="{ 'background-color': item.value.color }"
        />

        <section>
          {{ item.value.name }}
        </section>
      </section>
    </template>

    <template #append-item>
      <InlineLoadingIndicator
        v-if="isLoading"
        embedded
      />

      <div
        v-intersect="onFullyScrolled"
        class="h-4"
      />
    </template>

    <template #no-data>
      <EmptyState
        v-if="!isLoading && !properties.length"
        embedded
      />
    </template>
  </v-select>
</template>

<script setup lang="ts">
import { ref, watch } from 'vue';
import { VSelect, VTextField } from 'vuetify/components';

import { HttpClient } from '@/http';
import { usePagination } from '@/composables';

import { MIN_SEARCH_TERM_LENGTH } from '@/declarations';
import { getCapacityLabel, debounce } from '@/utils';

import EmptyState from '@/components/layout/EmptyState.vue';
import InlineLoadingIndicator from '@/components/layout/InlineLoadingIndicator.vue';

defineProps<{ modelValue: IProperty | null }>();
const emit = defineEmits(['update:modelValue']);

const PROPERTIES_LIST_SIZE = 10;

const pagination = usePagination({ size: PROPERTIES_LIST_SIZE });

const properties = ref<IProperty[]>([]);
const selectedProperty = ref<IProperty | null>(null);

const term = ref('');
const isLoading = ref(false);

const onFocus = async (isFocused: boolean) => {
  if (!isFocused || isLoading.value) {
    return;
  }

  await fetchData({ reset: true });
};

const onSearchInput = debounce(500, (event: InputEvent) => {
  const target = event.target as HTMLInputElement;
  const value = target.value;

  const currentTerm = value?.trim() ?? '';

  if (currentTerm && currentTerm.length < MIN_SEARCH_TERM_LENGTH) {
    return;
  }

  term.value = currentTerm;
});

const onFullyScrolled = (isIntersecting: boolean) => {
  const isDataLoaded = (
    properties.value.length < PROPERTIES_LIST_SIZE
  );

  if (!isIntersecting || isDataLoaded) {
    return;
  }

  fetchData({ reset: false });
};

const fetchData = async (options: Partial<PageFetchDataOptions>) => {
  isLoading.value = true;

  if (options.reset) pagination.resetPage();
  if (!options.reset) pagination.nextPage();

  const response = await HttpClient.get<IProperty[]>('/v1/properties', {
    params: {
      limit: PROPERTIES_LIST_SIZE,
      offset: pagination.offset.value,
      ...(term.value && { term: term.value }),
    },
  });

  isLoading.value = false;

  if (!response.data.values) {
    return;
  }

  properties.value = options.reset
    ? response.data.values
    : [...properties.value, ...response.data.values];
};

watch(term, () => fetchData({ reset: true }));
watch(selectedProperty, value => emit('update:modelValue', value));
</script>